VERSION 5.00
Object = "{19BCF088-5E46-11D2-9EC8-2CF807C10000}#1.1#0"; "CCRPFTV.OCX"
Begin VB.Form Form1 
   Caption         =   "CCRP FTV cancel expand fix demo (VB5)"
   ClientHeight    =   6630
   ClientLeft      =   2100
   ClientTop       =   1860
   ClientWidth     =   6315
   ClipControls    =   0   'False
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   6630
   ScaleWidth      =   6315
   Begin VB.CheckBox Check2 
      Caption         =   "Cancel folder expands without preventing duplicate folder reloading"
      Height          =   315
      Left            =   540
      TabIndex        =   6
      Top             =   6090
      Width           =   5415
   End
   Begin VB.CheckBox Check1 
      Caption         =   "Cancel folder expands and prevent duplicate folder reloading"
      Height          =   315
      Left            =   540
      TabIndex        =   5
      Top             =   5700
      Width           =   5415
   End
   Begin CCRPFolderTV.FolderTreeview FolderTreeview1 
      Height          =   3420
      Left            =   780
      TabIndex        =   4
      Top             =   2070
      Width           =   4695
      _ExtentX        =   8281
      _ExtentY        =   6033
   End
   Begin VB.Label Label4 
      Caption         =   "4. Repeat the process again, but instead check and uncheck the first checkbox, preventing the duplicate folders from being loaded."
      Height          =   525
      Left            =   780
      TabIndex        =   3
      Top             =   1500
      Width           =   4755
   End
   Begin VB.Label Label3 
      Caption         =   "3. Press F5 to refresh the the FTV, removing the duplicate folders."
      Height          =   315
      Left            =   780
      TabIndex        =   2
      Top             =   1140
      Width           =   4755
   End
   Begin VB.Label Label2 
      Caption         =   "2. Next uncheck the CheckBox, again expand the My Computer folder (this time it will expand), and notice the duplicate folders."
      Height          =   495
      Left            =   780
      TabIndex        =   1
      Top             =   600
      Width           =   4755
   End
   Begin VB.Label Label1 
      Caption         =   "1. First check the second CheckBox below and attempt to expand the My Computer folder (it won't expand since we're cancelling it)."
      Height          =   465
      Left            =   780
      TabIndex        =   0
      Top             =   90
      Width           =   4755
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'
' Brought to you by Brad Martinez
'   http://www.mvps.org/ccrp/
'   news://news.mvps.org/ccrp.foldertreeview
'
' Provides a work around for the bug in the CCRP FolderTreeview control
' v0.03.0023 where duplicate folders are loaded under a folder whose
' Expand event was cancelled.
'
' Please refer to the CCRP web site's FAQ Help area for more information.
'

Private Sub Form_Load()
  KeyPreview = True
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  If (KeyCode = vbKeyF5) Then FolderTreeview1.Refresh
End Sub

Private Sub FolderTreeview1_Expand(Folder As CCRPFolderTV.Folder, PreExpand As Boolean, Cancel As Boolean)
  
  ' If the folder is in the process of expanding and the expand is going
  ' to be cancelled...
  If PreExpand And ((Check1 = vbChecked) Or (Check2 = vbChecked)) Then
    
    ' If preventing duplicate folder reloading...
    If (Check1 = vbChecked) Then
      
      ' If the TVIS_EXPANDEDONCE treeview item state bit of the expanding
      ' folder has not yet been set...
      If (GetTVItemState(FolderTreeview1.hWnd, Folder.hItemTV) And _
          TVIS_EXPANDEDONCE) = False Then
        
        ' Set the bit for the FTV (it forgets to do this).
        Call SetTVItemState(FolderTreeview1.hWnd, Folder.hItemTV, TVIS_EXPANDEDONCE, True)
        
      End If
    End If
    
    ' Cancel the expand.
    Cancel = True
    
  End If
  
End Sub
